
/*
Copyright 2007 Kim A. Brandt <kimabrandt@gmx.de>

This file is part of prefswitch.

Prefswitch is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Prefswitch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with prefswitch; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

function Preference(name, type, value, description)
{
	this.name = null;
	this.type = null;
	this.value = null;
	this.description = null;

	this.setName = function(value)
	{
		if(value == null) value = "";
		this.name = value;
	};

	this.setType = function(value)
	{
		if(value == null) value = "";
		switch(value)
		{
			case INTEGER: this.type = INTEGER; break;
			case STRING: this.type = STRING; break;
			case RESET: this.type = RESET; break;
			default: this.type = BOOLEAN;
		}
	};

	this.setValue = function(value)
	{
		if(value == null) value = "";
		this.value = "" + value;
	};

	this.setDescription = function(value)
	{
		if(value == null) value = "";
		this.description = value;
	};

	this.getName = function()
	{
		return this.name;
	};

	this.getType = function()
	{
		return this.type;
	};

	this.getTypeInt = function()
	{
		switch(this.type)
		{
			case INTEGER: return 1;
			case STRING: return 2;
			default: return 0;
		}
	};

	this.getValue = function()
	{
		return this.value;
	};

	this.getDescription = function()
	{
		return this.description;
	};

	this.createClone = function()
	{
		var pref = new Preference();
		pref.name = this.name;
		pref.type = this.type;
		pref.value = this.value;
		pref.description = this.description;
		return pref;
	};

	this.setName(name);
	this.setType(type);
	this.setValue(value);
	this.setDescription(description);
}
